import logging
import os.path
import kraken.Constants
from kraken.tools.TextUi import inputString
from kraken.entrytypes.Entry import Entry, loadKraEntry, getEntryRdfFile
from kraken.entrytypes.MetaData import loadMetaData, updateCache

# 
#   The description of the annotate entry stuff
# 
def description(system, runtime):
    return """
    Annotates (edits) one of the entries. The directory of the entry needs
    to be passed to the command, for example:
       kraken --annotate-entry=kra001
    """

# 
#   Annotate entry
# 
def execute(system, runtime):
    if runtime.annotateEntry == None:
        runtime.annotateEntry = inputString("Annotate entry")
    print "Annotating entry: " + runtime.annotateEntry
    for kd in system.getProperty("krakenDirs"):
       val = __annotateSingleEntry(system, runtime, kd)
       if val:
           return
    logging.warning("Could not find entry: "+runtime.annotateEntry)
    
        
# 
#   Annotates a single entry from the directory of the kraken
# 
def __annotateSingleEntry(system, runtime, directory):
    dirname = os.path.join(directory, runtime.annotateEntry)
    if not os.path.isdir(dirname):
        return 0
    try:
        entry = loadKraEntry(system, dirname)
    except:
        logging.critical("The entry:" + runtime.annotateEntry + " was not found")
        return
    if (entry == None):
        return 0
    entry.krakenDirName = directory
    print entry
    entry.edit()
    entry.writeRDF(os.path.join(directory, runtime.annotateEntry))
    # FIXME: the cache can be updated without regenerating.  
    metadata = loadMetaData(system, runtime)
    metadata.updateEntry(entry)
    updateCache(system, runtime, metadata)
    return 1
