import os.path
import logging

#
#  Check the system parameters
#  TODO: check for existence as well and the presence of the KRAKEN files
# 
def execute(system, runtime):
    # Convert all the paths to the Unix path
    print "Checking destination directory..."
    system.addProperty("destinationDir", os.path.normpath(system.getProperty("destinationDir")))
    if (not os.path.isdir(system.getProperty("destinationDir"))):
        logging.critical("The destination directory does not exist:" + 
            system.getProperty("destinationDir"))
            
            
    # the kraken dirs            
    print "Checking kraken directories..."
    newDirs = []
    for a in system.getProperty("krakenDirs"):
        kdir = os.path.normpath(a)
        if (not os.path.isdir(kdir)):
           logging.critical("The kraken source directory does not exist:" + kdir)
        newDirs.append(kdir)
    system.addProperty("krakenDirs", newDirs)
    
    # destination directory is a kraken dir.
    print "Checking if the destination dir is a kraken dir..."
    if not (system.getProperty("destinationDir") in system.getProperty("krakenDirs")):
       logging.critical("The destination directory " + system.getProperty("destinationDir") + 
           " is not one of the kraken directories " + str(system.getProperty("krakenDirs")))

    # the directory of the generated entries
    print "Checking the directory of generated entries..."
    system.addProperty("generatedEntryDir", os.path.normpath(system.getProperty("generatedEntryDir")))
    if (not os.path.isdir(system.getProperty("generatedEntryDir"))):
        logging.critical("The directory of generated entries does not exist:" + 
            system.getProperty("generatedEntryDir"))

    # the directory of the links
    print "Checking the directory of links..."
    system.addProperty("linkDir", os.path.normpath(system.getProperty("linkDir")))
    if (not os.path.isdir(system.getProperty("linkDir"))):
        logging.critical("The directory of links does not exist:" + 
            system.getProperty("linkDir"))
            
    # the staging dir            
    print "Checking the temporary (staging) directory..."
    system.addProperty("tempDir", os.path.normpath(system.getProperty("tempDir")))
    if (not os.path.isdir(system.getProperty("tempDir"))):
        logging.critical("The temporary directory does not exist:" + 
            system.getProperty("tempDir"))

