import logging
import kraken.Constants
import kraken.entrytypes.bibtex.Utilities
from kraken.entrytypes.opinion.Opinion import Opinion
import kraken.tools.TextUi as TextUi

def guessEntryType(entry):
   entrytypes = []
   if "Article" in entry.keywords:
      entrytypes.append(kraken.Constants.ENTRY_TYPE_BIBTEX)
   #if "Person" in entry.keywords:    
   #   entrytypes.append(kraken.Constants.ENTRY_TYPE_VCF)
   return entrytypes   
   

def edit(entry, metadata):
    entrytypes = guessEntryType(entry)
    logging.info("The guessed entry types were:" + str(entrytypes))
    if kraken.Constants.ENTRY_TYPE_BIBTEX in entrytypes:
        if TextUi.confirm("Do you want to edit this entry as a BibTeX entry?"):
           kraken.entrytypes.bibtex.Utilities.edit(entry)
    opinion = entry.getProperty("opinion")
    # FIXME: here we want to see about MY OPINION
    if (opinion == None):
        if not TextUi.confirm("Do you want to create the opinion attached to this entry?"):
            return
        else:
            opinion = Opinion()
            entry.addProperty("opinion", opinion) 
    # now, edit the opinion
    opinion.edit()
    
