import time
import os.path
import kraken.Constants
from TableFormat import TableFormat
       
       
# ***********************************************************
#  Generate web page
# ***********************************************************

def generateText(system, runtime, metadata): 
        temp = "Number of entries = " + str(len(metadata.entries)) + "\n"        
        for a in metadata.entries:
            temp += a.title + "\t" + a.label + "\n"
        return temp

'''
   Local comparison function for the ranking
   FIXME: to be superseeded by a generalized scoring / ranking stuff
'''
def localcompare(a, b):
    aop = a.getProperty("opinion")
    if aop == None:
        arank = 0
    else:
        arank = aop.getProperty("ranking")
    bop = b.getProperty("opinion")
    if bop == None:
        brank = 0
    else:
        brank = bop.getProperty("ranking")    
    return cmp(brank, arank)    
      
        
       
        
# ***********************************************************
#  Generate web page
# ***********************************************************

def generateHtml(system, runtime, metadata):
       temp = "";
       temp += "<html>\n"
       temp += "<head>\n"
       # Fixme: we will need this
       temp += '<link HREF="' + kraken.Constants.DEFAULT_CSS_FILENAME + '" REL="STYLESHEET" LANG="en.us">'
       temp += "</head>\n"
       #temp += generateTable(system, metadata)
       temp += __generateHeader(system, runtime, metadata)
       # applying the sorting: it shouldn't happen here
       metadata.entries.sort(localcompare)
       tf = TableFormat()
       temp += tf.generateEntryTable(metadata)
       temp += "</html>\n"
       return temp

def __generateHeader(system, runtime, metadata):
    temp = ""
    temp +='<p><b>Generated on:</b>' + time.strftime("%a, %d %b %Y %H:%M:%S +0000", time.localtime())
    # fixme write out the query
    # temp +="<p><b>Filter all keywords:</b> " + runtime.selectKeywordsAll
    # temp +="<p><b>Filter any keywords:</b> " + runtime.selectKeywordsAny
    
    return temp


