import unittest
import os
import testBasics
import testWebAccess
import testQuery
import kraken.Constants
import Constants

def createKrakenTestSuite():
    krakenTestSuite = unittest.TestSuite()
    # basic tests
    krakenTestSuite.addTest(testBasics.testBasics("testHelp"))
    krakenTestSuite.addTest(testBasics.testBasics("testAddLocalFile"))
    # web access tests
    krakenTestSuite.addTest(testWebAccess.testWebAccess("testAddWebpage"))
    # query tests
    krakenTestSuite.addTest(testQuery.testQuery("testAllKeywords"))
    krakenTestSuite.addTest(testQuery.testQuery("testAnyKeywords"))
    # these are all the tests
    return krakenTestSuite  

def prepareTestConfiguration(system, runtime):
    print "Backing up the original kraken configuration"
    filename = os.path.expanduser(kraken.Constants.SYSTEM_FILE)
    try:
       os.rename(filename, filename+".BAK")
    except:
       print "System file " + filename + " does not exist"        
    filename = os.path.expanduser(kraken.Constants.METADATA_FILE)
    try:
       os.rename(filename, filename+".BAK")
    except:
       print "Metadata file " + filename + " does not exist"
    # now, create a new one
    os.system("./kraken.py --show-config")
    os.system("./kraken.py --destdir=" + Constants.TEST_DEST_DIR)
    os.system("./kraken.py --tempdir=" + Constants.TEST_TEMP_DIR)
    os.system("./kraken.py --add-directory=kraken/test/destdir")
    # FIXME: this is hardcoded, it should not be
    os.system("./kraken.py --remove-directory=/home/lboloni/.kraken/kraken/")
    os.system("./kraken.py --show-config")
    
def restoreOriginalConfiguration(system, runtime):
    print "Restoring the kraken configuration NOT WORKING!!!"
